[{
  Name: "My Energy Monitor",
  Author: "Louis Brons",
  Version: "2015-12-31",

  GroupName: '',
  IconImage: 'pages/control/widgets/homegenie/generic/images/power.png',
  StatusText: '',
  Description: '',
  Initialized: false,
  Widget: null,
  LastDrawStats: new Date(0),
  
  RenderView: function (cuid, module) {
    var container = $(cuid);
    var widget = this.Widget = container.find('[data-ui-field=widget]');
    if (!this.Initialized)
    {
      this.Widget.find('[data-ui-field=energystats]').qtip({
        id: 'flot',
        prerender: true,
        content: ' ',
        position: {
          target: 'mouse',
          viewport: $('#flot'),
          adjust: {
            x: 5
          }
        },
        show: false,
        hide: {
          event: false,
          fixed: true
        }
      });
      this.Widget.find('[data-ui-field=energystats]').bind("plothover", function (event, pos, item) {
        // Grab the API reference
        var graph = $(this),
            api = graph.qtip(),
            previousPoint;
        // If we weren't passed the item object, hide the tooltip and remove cached point data
        if (!item) {
          api.cache.point = false;
          return api.hide(item);
        }
        previousPoint = api.cache.point;
        if (previousPoint !== item.dataIndex) {
          var offset = new Date().getTimezoneOffset() * 60 * 1000;
          api.cache.point = item.dataIndex;

          api.set('content.text',
                  item.series.label + " at " + new Date(item.datapoint[0] + offset).toLocaleTimeString() + " = " + item.datapoint[1].toFixed(4));

          api.elements.tooltip.stop(1, 1);
          api.show(item);
        }
      });
    }
    // render widget
    this.DrawData();
    var elapsedMinutes = ((new Date() - this.LastDrawStats) / 1000 / 60);
    if (elapsedMinutes >= 1) {
      this.LastDrawStats = new Date();
      this.DrawStats('');
    }
  },

  DrawData: function() {
    var _this = this;
    var myenergymodule = HG.WebApp.Utility.GetModuleByDomainAddress('HomeAutomation.MyEnergyMonitor', '1');
    var lights = HG.WebApp.Utility.GetModulePropertyByName(myenergymodule, 'MyEnergyMonitor.OperatingLights').Value;
    var switches = HG.WebApp.Utility.GetModulePropertyByName(myenergymodule, 'MyEnergyMonitor.OperatingSwitches').Value;
	var realLoad = HG.WebApp.Utility.GetModulePropertyByName(myenergymodule,'MyEnergyMonitor.RealUsed').Value ;
    this.Widget.find('[data-ui-field=realUsed]').html(realLoad);
    this.Widget.find('[data-ui-field=lightcount]').html(lights);
    this.Widget.find('[data-ui-field=switchcount]').html(switches);
  },
  DrawStats: function(mod) {
    var _this = this;
    var showsplines = false;
    var showlines = false;
    var showbars = true;
    var datum = new Date().toJSON().slice(0,10);
	
    var myenergymodule = HG.WebApp.Utility.GetModuleByDomainAddress('HomeAutomation.MyEnergyMonitor', '1');

    
    var powerUsage = JSON.parse(HG.WebApp.Utility.GetModulePropertyByName(myenergymodule,'MyEnergyMonitor.History').Value);
	
    var dataSerie = [];
    var yMin = 0;
    if (powerUsage.length > 0)
       yMin = powerUsage[powerUsage.length-1].Value;
    for (var x = 0; x < powerUsage.length; x+=Math.ceil(powerUsage.length/96)) {
          dataSerie.push([powerUsage[x].UnixTimestamp, powerUsage[x].Value]);
          if (yMin > powerUsage[x].Value)
            yMin = powerUsage[x].Value;
    
              try {
          var dateFormat = dataStore.get('UI.DateFormat');
          $.plot(_this.Widget.find('[data-ui-field=energystats]'), [
            { label: 'Actual usage&nbsp;', data: dataSerie, lines: { show: false, lineWidth: 2.0 }, bars: { show: false }, splines: { show: true }, points: { show: false } }
          ],
                 {
            yaxis: { 
                show: true, min: yMin 
            },
            xaxis: { mode: "time", useLocalTime: true, timeformat: (dateFormat == "MDY12" ? "%h%p" : "%h"), minTickSize: [2, "hour"], tickSize: [2, "hour"] },
            legend: { position: "nw", noColumns: 6, backgroundColor: 'rgba(0,0,0,0.4)' },
            lines: { 
              show: showlines, lineWidth: 1.0,
              fill: true,
              fillColor: { colors: [ { opacity: 0.0 }, { opacity: 1.0 } ] }
            },
            series: {
              splines: { show: showsplines }
            },
            grid: {
              color: 'white',
              backgroundColor: 'rgba(255,255,255, 0.2)',
              hoverable: true
            },
            colors: ["rgba(200, 255, 0, 1.0)"],
            points: { show: false },
            zoom: {
              interactive: false
            },
            pan: {
              interactive: false
            }
          });
        } catch (e) { }

    

  	}
  }
}]

